using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using ADODB;
using System.IO;
using System.CodeDom;
using System.CodeDom.Compiler;

using NBearLite;
using System.Data.Common;
using System.Data.SqlClient;
using System.Data.OracleClient;
using System.Data.SQLite;
using MySql.Data.MySqlClient;
using Npgsql;


namespace NBearLite.QueryColumnsGenerator
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnConnect_Click(object sender, EventArgs e)
        {
            if (txtConnStr.Text.Trim().Length == 0)
            {
                MessageBox.Show("Connection string cannot be null!");
                return;
            }

            if (btnConnect.Text == "Disconnect")
            {
                EnableGenEntity(false);
                return;
            }

            RefreshConnectionStringAutoComplete();

            DataSet dsTables = null;
            DataSet dsViews = null;

            if (radioSql.Checked || radioAccess.Checked)
            {
                try
                {
                    if (radioSql.Checked)
                    {
                        Database.Default = new Database(DatabaseType.SqlServer, txtConnStr.Text);
                        if (checkSql2005.Checked)
                        {
                            dsTables = Database.Default.CustomSql("select [name] from sysobjects where xtype = 'U' and [name] <> 'sysdiagrams' order by [name]").ToDataSet();
                        }
                        else
                        {
                            dsTables = Database.Default.CustomSql("select [name] from sysobjects where xtype = 'U' and status > 0 order by [name]").ToDataSet();
                        }
                        foreach (DataRow row in dsTables.Tables[0].Rows)
                        {
                            tables.Items.Add(row["Name"].ToString());
                        }

                        if (checkSql2005.Checked)
                        {
                            dsViews = Database.Default.CustomSql("select [name] from sysobjects where xtype = 'V' order by [name]").ToDataSet();
                        }
                        else
                        {
                            dsViews = Database.Default.CustomSql("select [name] from sysobjects where xtype = 'V' and status > 0 order by [name]").ToDataSet();
                        }
                        foreach (DataRow row in dsViews.Tables[0].Rows)
                        {
                            views.Items.Add(row["Name"].ToString());
                        }

                        EnableGenEntity(true);
                    }
                    else if (radioAccess.Checked)
                    {
                        Database.Default = new Database(DatabaseType.MsAccess, txtConnStr.Text);
                        ADODB.ConnectionClass conn = new ADODB.ConnectionClass();
                        conn.Provider = "Microsoft.Jet.OLEDB.4.0";
                        string connStr = txtConnStr.Text;
                        conn.Open(connStr.Substring(connStr.ToLower().IndexOf("data source") + "data source".Length).Trim('=', ' '), null, null, 0);

                        ADODB.Recordset rsTables = conn.GetType().InvokeMember("OpenSchema", BindingFlags.InvokeMethod, null, conn, new object[] { ADODB.SchemaEnum.adSchemaTables }) as ADODB.Recordset;
                        ADODB.Recordset rsViews = conn.GetType().InvokeMember("OpenSchema", BindingFlags.InvokeMethod, null, conn, new object[] { ADODB.SchemaEnum.adSchemaViews }) as ADODB.Recordset;

                        while (!rsViews.EOF)
                        {
                            if (!(rsViews.Fields["TABLE_NAME"].Value as string).StartsWith("MSys"))
                            {
                                views.Items.Add(rsViews.Fields["TABLE_NAME"].Value.ToString());
                            }
                            rsViews.MoveNext();
                        }

                        while (!rsTables.EOF)
                        {
                            if (!(rsTables.Fields["TABLE_NAME"].Value as string).StartsWith("MSys"))
                            {
                                bool isView = false;
                                foreach (string item in views.Items)
                                {
                                    if (item.Equals(rsTables.Fields["TABLE_NAME"].Value.ToString()))
                                    {
                                        isView = true;
                                        break;
                                    }
                                }
                                if (!isView)
                                {
                                    tables.Items.Add(rsTables.Fields["TABLE_NAME"].Value.ToString());
                                }
                            }
                            rsTables.MoveNext();
                        }

                        rsTables.Close();
                        rsViews.Close();

                        conn.Close();
                    }

                    EnableGenEntity(true);
                }
                catch (Exception ex)
                {
                    EnableGenEntity(false);
                    MessageBox.Show("Read/write database error!\r\n" + ex.ToString());
                }
            }
            else if (radioOracle.Checked)
            {
                Database.Default = new Database(DatabaseType.Oracle, txtConnStr.Text);

                dsTables = Database.Default.CustomSql("select * from user_tables where (not table_name like '%$%') and TABLE_NAME <> 'SQLPLUS_PRODUCT_PROFILE' and TABLE_NAME <> 'HELP'").ToDataSet();
                foreach (DataRow row in dsTables.Tables[0].Rows)
                {
                    tables.Items.Add(row["TABLE_NAME"].ToString());
                }

                dsViews = Database.Default.CustomSql("select * from user_views where (not view_name like '%$%') and (not view_name like 'MVIEW_%') and (not view_name like 'CTX_%') and (not view_name = 'PRODUCT_PRIVS')").ToDataSet();
                foreach (DataRow row in dsViews.Tables[0].Rows)
                {
                    views.Items.Add(row["VIEW_NAME"].ToString());
                }

                EnableGenEntity(true);
            }
            else if (radioMySql.Checked)
            {
                System.Text.RegularExpressions.Regex r = new System.Text.RegularExpressions.Regex("(^.*database=)([^;]+)(;.*)", System.Text.RegularExpressions.RegexOptions.IgnoreCase);
                string dbName = r.Replace(txtConnStr.Text, "$2").ToLower();
                Database.Default = new Database(DatabaseType.MySql, r.Replace(txtConnStr.Text, "$1information_schema$3"));

                dsTables = Database.Default.CustomSql("select * from TABLES where TABLE_TYPE = 'BASE TABLE' and TABLE_SCHEMA = '" + dbName + "'").ToDataSet();
                foreach (DataRow row in dsTables.Tables[0].Rows)
                {
                    tables.Items.Add(row["TABLE_NAME"].ToString());
                }

                dsViews = Database.Default.CustomSql("select * from TABLES where TABLE_TYPE = 'VIEW' and TABLE_SCHEMA = '" + dbName + "'").ToDataSet();
                foreach (DataRow row in dsViews.Tables[0].Rows)
                {
                    views.Items.Add(row["TABLE_NAME"].ToString());
                }

                EnableGenEntity(true);
            }
            else if (radioPostgreSql.Checked)
            {
                Database.Default = new Database(DatabaseType.PostgreSql, txtConnStr.Text);
                dsTables = Database.Default.CustomSql("select tablename from pg_tables where schemaname = 'public'").ToDataSet();
                foreach (DataRow row in dsTables.Tables[0].Rows)
                {
                    tables.Items.Add(row["tablename"].ToString());
                }

                dsViews = Database.Default.CustomSql("select viewname from pg_views where schemaname = 'public'").ToDataSet();
                foreach (DataRow row in dsViews.Tables[0].Rows)
                {
                    views.Items.Add(row["viewname"].ToString());
                }

                EnableGenEntity(true);
            }
            else if (radioSqlite.Checked)
            {
                List<string> systemTables = new List<string>();
                systemTables.Add("fulltext");
                systemTables.Add("fulltext_content");
                systemTables.Add("fulltext_term");
                systemTables.Add("keyinfotest");
                systemTables.Add("xp_proc");
                systemTables.Add("sqlite_master");
                systemTables.Add("sqlite_sequence");

                Database.Default = new Database(DatabaseType.Sqlite, txtConnStr.Text);
                dsTables = Database.Default.CustomSql("select tbl_name from sqlite_master where type = 'table'").ToDataSet();
                foreach (DataRow row in dsTables.Tables[0].Rows)
                {
                    if (!systemTables.Contains(row["tbl_name"].ToString().ToLower()))
                        tables.Items.Add(row["tbl_name"].ToString());
                }

                dsViews = Database.Default.CustomSql("select tbl_name from sqlite_master where type = 'view'").ToDataSet();
                foreach (DataRow row in dsViews.Tables[0].Rows)
                {
                    if (!systemTables.Contains(row["tbl_name"].ToString().ToLower()))
                        views.Items.Add(row["tbl_name"].ToString());
                }

                EnableGenEntity(true);
            }
            else
            {
                EnableGenEntity(false);
                MessageBox.Show("Only supports SqlServer, MsAccess, MySql, Oracle, Sqlite and PostgreSql Database!");
            }
        }

        private AutoCompleteStringCollection connStrs = new AutoCompleteStringCollection();
        private static string CONN_STR_HIS_File = AppDomain.CurrentDomain.BaseDirectory.Trim('\\') + "\\ConnectionStringsHistory.txt";

        public void RefreshConnectionStringAutoComplete()
        {
            if (!string.IsNullOrEmpty(txtConnStr.Text))
            {
                if (!connStrs.Contains(txtConnStr.Text))
                {
                    connStrs.Add(txtConnStr.Text);
                }
            }
        }

        private void SaveConnectionStringAutoComplete()
        {
            StreamWriter sw = new StreamWriter(CONN_STR_HIS_File);

            foreach (string line in connStrs)
            {
                sw.WriteLine(line);
            }

            sw.Close();
        }

        private void LoadConnectionStringAutoComplete()
        {
            if (File.Exists(CONN_STR_HIS_File))
            {
                connStrs.Clear();

                StreamReader sr = new StreamReader(CONN_STR_HIS_File);
                while (!sr.EndOfStream)
                {
                    connStrs.Add(sr.ReadLine().Trim());
                }
                sr.Close();
            }

            txtConnStr.AutoCompleteCustomSource = connStrs;
        }

        private void EnableGenEntity(bool enable)
        {
            if (enable)
            {
                btnGen.Enabled = true;
                txtConnStr.Enabled = false;
                btnConnect.Text = "Disconnect";

                radioAccess.Enabled = false;
                radioMySql.Enabled = false;
                radioOracle.Enabled = false;
                radioSql.Enabled = false;
            }
            else
            {
                btnGen.Enabled = false;
                txtConnStr.Enabled = true;
                btnConnect.Text = "Connect";
                selectAll.Checked = false;
                tables.Items.Clear();
                views.Items.Clear();
                output.Text = "";

                radioAccess.Enabled = true;
                radioMySql.Enabled = true;
                radioOracle.Enabled = true;
                radioSql.Enabled = true;
            }
        }

        private void selectAll_CheckedChanged(object sender, EventArgs e)
        {
            if (selectAll.Checked)
            {
                for (int i = 0; i < tables.Items.Count; i++ )
                {
                    tables.SetItemChecked(i, true);
                }
                for (int i = 0; i < views.Items.Count; i++)
                {
                    views.SetItemChecked(i, true);
                }
            }
            else
            {
                for (int i = 0; i < tables.Items.Count; i++)
                {
                    tables.SetItemChecked(i, false);
                }
                for (int i = 0; i < views.Items.Count; i++)
                {
                    views.SetItemChecked(i, false);
                }
            }
        }

        private void GenQueryColumnsForTableOrView(string name, CodeNamespace __ns, CodeTypeDeclaration rootClass)
        {
            DataSet ds = null;

            if (radioAccess.Checked || radioSql.Checked)
            {
                ds = Database.Default.CustomSql(string.Format("select * from [{0}] where 1 = 2", name)).ToDataSet();
            }
            else if (radioMySql.Checked)
            {
                Database dbDatabase = new Database(DatabaseType.MySql, txtConnStr.Text);
                ds = dbDatabase.CustomSql(string.Format("select * from `{0}` where 1 = 2", name)).ToDataSet();
            }
            else //Oracle
            {
                ds = Database.Default.CustomSql(string.Format("select * from \"{0}\" where 1 = 2", name)).ToDataSet();
            }

            //generate code, add types to __ns, add static instance to rootClass
            
            CodeTypeDeclaration tableClass = new CodeTypeDeclaration(name.Replace(" ", string.Empty) + "_Columns");
            __ns.Types.Add(tableClass);
            tableClass.Attributes = MemberAttributes.Public | MemberAttributes.Final;
            tableClass.IsClass = true;
            tableClass.IsPartial = false;
            tableClass.BaseTypes.Add(typeof(IQueryTable));

            //gen ___TABLE_NAME Field
            CodeMemberField tableNamefield = new CodeMemberField();
            tableNamefield.Name = "___TABLE_NAME";
            tableNamefield.Attributes = MemberAttributes.Private | MemberAttributes.Const;
            tableNamefield.Type = new CodeTypeReference(typeof(string), CodeTypeReferenceOptions.GlobalReference);
            tableNamefield.InitExpression = new CodePrimitiveExpression(name);
            tableClass.Members.Add(tableNamefield);

            //gen IQueryTable.___GetTableName() method
            CodeMemberMethod getTableNameMethod = new CodeMemberMethod();
            getTableNameMethod.Name = "___GetTableName";
            getTableNameMethod.ImplementationTypes.Add(typeof(IQueryTable));
            getTableNameMethod.Attributes = MemberAttributes.Public | MemberAttributes.Final;
            getTableNameMethod.ReturnType = new CodeTypeReference(typeof(string));
            getTableNameMethod.Statements.Add(new CodeMethodReturnStatement(new CodeVariableReferenceExpression("___TABLE_NAME")));
            tableClass.Members.Add(getTableNameMethod);

            //gen aliasNameField
            CodeMemberField aliasNamefield = new CodeMemberField();
            aliasNamefield.Name = "___aliasName";
            aliasNamefield.Attributes = MemberAttributes.Private;
            aliasNamefield.Type = new CodeTypeReference(typeof(string), CodeTypeReferenceOptions.GlobalReference);
            tableClass.Members.Add(aliasNamefield);

            //gen constructor1
            CodeConstructor con1 = new CodeConstructor();
            con1.Attributes = MemberAttributes.Public;
            con1.Name = name.Replace(" ", string.Empty);
            con1.Parameters.Add(new CodeParameterDeclarationExpression(typeof(string), "aliasName"));
            con1.Statements.Add(new CodeAssignStatement(
                new CodeFieldReferenceExpression(new CodeThisReferenceExpression(), "___aliasName"),
                new CodeVariableReferenceExpression("aliasName")
                ));
            tableClass.Members.Add(con1);

            //gen constructor2
            CodeConstructor con2 = new CodeConstructor();
            con2.Attributes = MemberAttributes.Public;
            con2.Name = name.Replace(" ", string.Empty);
            con2.Statements.Add(new CodeAssignStatement(
                new CodeFieldReferenceExpression(new CodeThisReferenceExpression(), "___aliasName"),
                new CodeVariableReferenceExpression("___TABLE_NAME")
                ));
            tableClass.Members.Add(con2);

            foreach (DataColumn column in ds.Tables[0].Columns)
            {
                //gen static field
                CodeMemberField field = new CodeMemberField();
                field.Name = '_' + column.ColumnName.Replace(" ", string.Empty);
                field.Attributes = MemberAttributes.Private | MemberAttributes.Static;
                field.Type = new CodeTypeReference(typeof(QueryColumn));
                field.InitExpression = new CodeObjectCreateExpression(field.Type, 
                    new CodeExpression[] { 
                        new CodeBinaryOperatorExpression(
                        new CodeVariableReferenceExpression("___TABLE_NAME"),
                        CodeBinaryOperatorType.Add,
                        new CodePrimitiveExpression("." + column.ColumnName)
                        ),
                        new CodeFieldReferenceExpression(new CodeTypeReferenceExpression(typeof(DbType)), GetDbType(column.DataType, GenSqlColumnType(name, column.ColumnName)).ToString())
                    });
                tableClass.Members.Add(field);

                //gen property
                CodeMemberProperty property = new CodeMemberProperty();
                property.Name = column.ColumnName.Replace(" ", string.Empty);
                property.Attributes = MemberAttributes.Public | MemberAttributes.Final;
                property.Type = new CodeTypeReference(typeof(QueryColumn));
                property.HasGet = true;
                property.HasSet = false;
                CodeConditionStatement condition = new CodeConditionStatement();
                condition.Condition = new CodeBinaryOperatorExpression(
                    new CodeFieldReferenceExpression(new CodeThisReferenceExpression(), "___aliasName"), 
                    CodeBinaryOperatorType.IdentityEquality,
                    new CodeVariableReferenceExpression("___TABLE_NAME"));
                condition.TrueStatements.Add(new CodeMethodReturnStatement(new CodeVariableReferenceExpression(field.Name)));
                condition.FalseStatements.Add(new CodeMethodReturnStatement(new CodeObjectCreateExpression(
                    new CodeTypeReference(typeof(QueryColumn)),
                    new CodeBinaryOperatorExpression(
                        new CodeFieldReferenceExpression(new CodeThisReferenceExpression(), "___aliasName"),
                        CodeBinaryOperatorType.Add,
                        new CodePrimitiveExpression("." + column.ColumnName)
                        ),
                    new CodeFieldReferenceExpression(new CodeTypeReferenceExpression(typeof(DbType)), GetDbType(column.DataType, GenSqlColumnType(name, column.ColumnName)).ToString())
                    )));
                property.GetStatements.Add(condition);
                tableClass.Members.Add(property);
            }

            //gen __Alias()
            CodeMemberMethod aliasColumnsMethod = new CodeMemberMethod();
            aliasColumnsMethod.Attributes = MemberAttributes.Public | MemberAttributes.Final;
            aliasColumnsMethod.Name = "__Alias";
            aliasColumnsMethod.Parameters.Add(new CodeParameterDeclarationExpression(new CodeTypeReference(typeof(string)), "aliasName"));
            aliasColumnsMethod.ReturnType = new CodeTypeReference(__ns.Name + "." + tableClass.Name);
            aliasColumnsMethod.Statements.Add(new CodeMethodReturnStatement(new CodeObjectCreateExpression(
                aliasColumnsMethod.ReturnType,
                new CodeVariableReferenceExpression("aliasName")
                )));
            tableClass.Members.Add(aliasColumnsMethod);

            CodeMemberField tableField = new CodeMemberField();
            tableField.Name = name.Replace(" ", string.Empty);
            tableField.Attributes = MemberAttributes.Public | MemberAttributes.Static;
            tableField.Type = new CodeTypeReference(__ns.Name + "." + tableClass.Name);
            tableField.InitExpression = new CodeObjectCreateExpression(tableField.Type);
            rootClass.Members.Add(tableField);
        }

        private DbType GetDbType(Type type, string dbType)
        {
            if (type.IsEnum)
            {
                return DbType.Int32;
            }
            else if (type == typeof(long) || type == typeof(long?))
            {
                return DbType.Int64;
            }
            else if (type == typeof(int) || type == typeof(int?))
            {
                return DbType.Int32;
            }
            else if (type == typeof(short) || type == typeof(short?))
            {
                return DbType.Int16;
            }
            else if (type == typeof(byte) || type == typeof(byte?))
            {
                return DbType.Byte;
            }
            else if (type == typeof(bool) || type == typeof(bool?))
            {
                return DbType.Boolean;
            }
            else if (type == typeof(decimal) || type == typeof(decimal?))
            {
                return DbType.Decimal;
            }
            else if (type == typeof(float) || type == typeof(float?))
            {
                return DbType.Double;
            }
            else if (type == typeof(double) || type == typeof(double?))
            {
                return DbType.Double;
            }
            else if (type == typeof(string))
            {
                return dbType.StartsWith("n") ? DbType.String : DbType.AnsiString;
            }
            else if (type == typeof(DateTime) || type == typeof(DateTime?))
            {
                return DbType.DateTime;
            }
            else if (type == typeof(char) || type == typeof(char?))
            {
                return DbType.Byte;
            }
            else if (type == typeof(byte[]))
            {
                return DbType.Binary;
            }
            else if (type == typeof(Guid) || type == typeof(Guid?))
            {
                return DbType.Guid;
            }

            return DbType.String;
        }

        private string GenSqlColumnType(string name, string column)
        {
            if (radioSql.Checked)
            {
                int tableid = Convert.ToInt32(Database.Default.CustomSql("select id from sysobjects where [name] = '" + name + "'").ToScalar());
                DataSet ds = Database.Default.CustomSql("select xtype, length, cdefault  from syscolumns where id = " + tableid + " and name = '" + column + "'").ToDataSet();
                object temp = Database.Default.CustomSql("select text from syscomments where id = " + ds.Tables[0].Rows[0]["cdefault"]).ToScalar();
                string df =null;
                if (temp != null && temp != DBNull.Value)
                {
                    df = temp.ToString();
                    df = outputLanguage.SelectedIndex == 0 ? df.Replace("\"", "\\\"") : df.Replace("\"", "\"\"");
                    if (df.StartsWith("(") && df.EndsWith(")") && df.Length > 2)
                    {
                        df = df.Substring(1, df.Length - 2);
                    }
                }
                switch (int.Parse(ds.Tables[0].Rows[0]["xtype"].ToString()))
                {
                    case 231:
                        return "nvarchar";
                    case 239:
                        return "nchar";
                    case 99:
                        return "ntext";
                    case 167:
                        return "varchar";
                    case 175:
                        return "char";
                    case 35:
                        return "text";
                }
            }
            else if (radioOracle.Checked)
            {
                object columnType = Database.Default.CustomSql(string.Format("SELECT DATA_TYPE FROM USER_TAB_COLUMNS WHERE TABLE_NAME= '{0}' AND COLUMN_NAME = '{1}'", name, column)).ToScalar();
                if (columnType != DBNull.Value)
                {
                    return columnType.ToString().ToLower();
                }
            }
            else if (radioMySql.Checked)
            {
                System.Text.RegularExpressions.Regex r = new System.Text.RegularExpressions.Regex("(^.*database=)([^;]+)(;.*)", System.Text.RegularExpressions.RegexOptions.IgnoreCase);
                string dbName = r.Replace(txtConnStr.Text, "$2").ToLower();
                Database schemaDb = new Database(DatabaseType.MySql, r.Replace(txtConnStr.Text, "$1information_schema$3"));

                object columnType = schemaDb.CustomSql(string.Format("SELECT DATA_TYPE FROM `COLUMNS` WHERE TABLE_SCHEMA = '{0}' and TABLE_NAME = '{1}' and COLUMN_NAME = '{2}'", dbName, name, column)).ToScalar();
                if (columnType != DBNull.Value)
                {
                    return columnType.ToString().ToLower();
                }
            }

            return "ntext";
        }

        private void btnGen_Click(object sender, EventArgs e)
        {
            output.Text = "Generating code, please stand by...";

            CodeCompileUnit unit = new CodeCompileUnit();

            //the ns
            CodeNamespace ns = new CodeNamespace(string.IsNullOrEmpty(txtOutNamespace.Text) ? "QueryColumns" : txtOutNamespace.Text);
            unit.Namespaces.Add(ns);

            //the __ns
            CodeNamespace __ns = new CodeNamespace(string.IsNullOrEmpty(txtOutNamespace.Text) ? "__QueryColumns" : "__" + txtOutNamespace.Text);
            unit.Namespaces.Add(__ns);

            //root class
            CodeTypeDeclaration rootClass = new CodeTypeDeclaration(string.IsNullOrEmpty(txtRootClass.Text) ? "Tables" : txtRootClass.Text);
            ns.Types.Add(rootClass);
            rootClass.Attributes = MemberAttributes.Static | MemberAttributes.Public;
            rootClass.IsClass = true;
            rootClass.IsPartial = false;

            //gen code for tables
            foreach (string table in tables.CheckedItems)
            {
                GenQueryColumnsForTableOrView(table, __ns, rootClass);
            }

            //gen code for views
            foreach (string view in views.CheckedItems)
            {
                GenQueryColumnsForTableOrView(view, __ns, rootClass);
            }

            //generate stored procedure wrappers if supports
            GenStoredProcedureWrappers(ns, rootClass);

            //output code
            CodeDomProvider provider;
            if (outputLanguage.SelectedIndex == 0)
                provider = new Microsoft.CSharp.CSharpCodeProvider();
            else
                provider = new Microsoft.VisualBasic.VBCodeProvider();

            StringBuilder codeBuilder = new StringBuilder();
            StringWriter stringWriter = new StringWriter(codeBuilder);
            IndentedTextWriter indentedWriter = new IndentedTextWriter(stringWriter, "  ");
            indentedWriter.Indent = 2;
            provider.GenerateCodeFromCompileUnit(unit, indentedWriter, new CodeGeneratorOptions());
            output.Text = codeBuilder.ToString();
        }

        private void GenStoredProcedureWrappers(CodeNamespace ns, CodeTypeDeclaration rootClass)
        {
            //Not supported databases: MsAccess, Sqlite

            List<DbCommand> spCmds = new List<DbCommand>();

            if (radioSql.Checked)
            {
                try
                {
                    Database.Default = new Database(DatabaseType.SqlServer, txtConnStr.Text);
                    DataSet dsSPs = Database.Default.CustomSql("select name from sysobjects where [type] = 'P' and name not like 'dt_%' order by name").ToDataSet();
                    for (int i = 0; i < dsSPs.Tables[0].Rows.Count; ++i)
                    {
                        spCmds.Add(Database.Default.GetStoredProcCommand(dsSPs.Tables[0].Rows[i][0].ToString()));
                        spCmds[i].Connection = Database.Default.GetConnection(true);
                        SqlCommandBuilder.DeriveParameters((SqlCommand)spCmds[i]);
                        Database.Default.CloseConnection(spCmds[i].Connection);
                        spCmds[i].Connection = null;
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Read/write database error!\r\n" + ex.ToString());
                }
            }
            else if (radioOracle.Checked)
            {
                Database.Default = new Database(DatabaseType.Oracle, txtConnStr.Text);
                DataSet dsSPs = Database.Default.CustomSql("SELECT NAME FROM user_source WHERE TYPE = 'PROCEDURE' AND LINE = 1 AND (NOT NAME LIKE '%$%') ORDER BY TEXT").ToDataSet();
                for (int i = 0; i < dsSPs.Tables[0].Rows.Count; ++i)
                {
                    spCmds.Add(Database.Default.GetStoredProcCommand(dsSPs.Tables[0].Rows[i][0].ToString()));
                    spCmds[i].Connection = Database.Default.GetConnection(true);
                    OracleCommandBuilder.DeriveParameters((OracleCommand)spCmds[i]);
                    Database.Default.CloseConnection(spCmds[i].Connection);
                    spCmds[i].Connection = null;
                }
            }
            else if (radioMySql.Checked)
            {
                System.Text.RegularExpressions.Regex r = new System.Text.RegularExpressions.Regex("(^.*database=)([^;]+)(;.*)", System.Text.RegularExpressions.RegexOptions.IgnoreCase);
                string dbName = r.Replace(txtConnStr.Text, "$2").ToLower();
                Database schemaDb = new Database(DatabaseType.MySql, r.Replace(txtConnStr.Text, "$1information_schema$3"));
                DataSet dsSPs = schemaDb.CustomSql(string.Format("SELECT SPECIFIC_NAME FROM ROUTINES WHERE ROUTINE_SCHEMA = '{0}' ORDER BY SPECIFIC_NAME", dbName)).ToDataSet();
                Database.Default = new Database(DatabaseType.MySql, txtConnStr.Text);
                for (int i = 0; i < dsSPs.Tables[0].Rows.Count; ++i)
                {
                    spCmds.Add(Database.Default.GetStoredProcCommand(dsSPs.Tables[0].Rows[i][0].ToString()));
                    spCmds[i].Connection = Database.Default.GetConnection(true);
                    MySqlCommandBuilder.DeriveParameters((MySqlCommand)spCmds[i]);
                    Database.Default.CloseConnection(spCmds[i].Connection);
                    spCmds[i].Connection = null;
                }
            }
            else if (radioPostgreSql.Checked)
            {
                Database.Default = new Database(DatabaseType.PostgreSql, txtConnStr.Text);
                DataSet dsSPs = Database.Default.CustomSql("select proname from pg_proc where pronamespace > 100 and (not proname like '_pg%') order by proname").ToDataSet();
                for (int i = 0; i < dsSPs.Tables[0].Rows.Count; ++i)
                {
                    spCmds.Add(Database.Default.GetStoredProcCommand(dsSPs.Tables[0].Rows[i][0].ToString()));
                    spCmds[i].Connection = Database.Default.GetConnection(true);
                    NpgsqlCommandBuilder.DeriveParameters((NpgsqlCommand)spCmds[i]);
                    Database.Default.CloseConnection(spCmds[i].Connection);
                    spCmds[i].Connection = null;
                    for (int j = 0; j < spCmds[i].Parameters.Count; ++j)
                    {
                        spCmds[i].Parameters[j].ParameterName = "p" + (j + 1).ToString();
                    }
                }
            }

            if (spCmds.Count > 0)
            {
                GenAStoredProcedureWrapperMethod(rootClass, spCmds, false);
                GenAStoredProcedureWrapperMethod(rootClass, spCmds, true);
            }
        }

        private void GenAStoredProcedureWrapperMethod(CodeTypeDeclaration rootClass, List<DbCommand> spCmds, bool generateTranParam)
        {
            foreach (DbCommand cmd in spCmds)
            {
                CodeMemberMethod spMethod = new CodeMemberMethod();
                spMethod.Attributes = MemberAttributes.Public | MemberAttributes.Static;
                spMethod.Name = cmd.CommandText.Replace(" ", string.Empty);
                spMethod.ReturnType = new CodeTypeReference(typeof(DataSet));
                rootClass.Members.Add(spMethod);

                //gen param - db
                CodeParameterDeclarationExpression dbParam =
                        new CodeParameterDeclarationExpression(typeof(Database), "db");
                spMethod.Parameters.Add(dbParam);

                if (generateTranParam)
                {
                    //gen param - tran
                    CodeParameterDeclarationExpression tranParam =
                           new CodeParameterDeclarationExpression(typeof(DbTransaction), "tran");
                    spMethod.Parameters.Add(tranParam);
                }

                //gen sp parameters
                bool containOutParam = false;
                for (int i = 0; i < cmd.Parameters.Count; ++i)
                {
                    Type paramType = GetTypeFromDbType(cmd.Parameters[i].DbType);
                    string paramName = cmd.Parameters[i].ParameterName.Substring(1);
                    ParameterDirection paramDirection = cmd.Parameters[i].Direction;

                    CodeParameterDeclarationExpression newParam =
                        new CodeParameterDeclarationExpression(paramType, paramName);
                    if (paramDirection == ParameterDirection.InputOutput)
                    {
                        newParam.Direction = FieldDirection.Ref;
                        containOutParam = true;
                    }
                    else if (paramDirection == ParameterDirection.Output || paramDirection == ParameterDirection.ReturnValue)
                    {
                        newParam.Direction = FieldDirection.Out;
                        containOutParam = true;
                    }

                    spMethod.Parameters.Add(newParam);
                }

                //gen statements

                //check parameter: db
                spMethod.Statements.Add(
                    new CodeConditionStatement(
                        new CodeBinaryOperatorExpression(new CodeVariableReferenceExpression("db"), CodeBinaryOperatorType.IdentityEquality, new CodePrimitiveExpression(null)),
                        new CodeThrowExceptionStatement(new CodeObjectCreateExpression(typeof(ArgumentNullException), new CodePrimitiveExpression("db"), new CodePrimitiveExpression("Parameter: db could not be null!")))
                        )
                    );

                if (generateTranParam)
                {
                    //check parameter: tran
                    spMethod.Statements.Add(
                        new CodeConditionStatement(
                            new CodeBinaryOperatorExpression(new CodeVariableReferenceExpression("tran"), CodeBinaryOperatorType.IdentityEquality, new CodePrimitiveExpression(null)),
                            new CodeThrowExceptionStatement(new CodeObjectCreateExpression(typeof(ArgumentNullException), new CodePrimitiveExpression("tran"), new CodePrimitiveExpression("Parameter: tran could not be null!")))
                            )
                        );
                }

                //construct StoredProcedureSection
                spMethod.Statements.Add(new CodeVariableDeclarationStatement(typeof(StoredProcedureSection), "spSection",
                    new CodeMethodInvokeExpression(
                        new CodeVariableReferenceExpression("db"),
                        "StoredProcedure",
                        new CodePrimitiveExpression(cmd.CommandText)
                        )));

                if (generateTranParam)
                {
                    //set tran of StoredProcedureSection
                    spMethod.Statements.Add(
                        new CodeMethodInvokeExpression(new CodeVariableReferenceExpression("spSection"), "SetTransaction",
                            new CodeVariableReferenceExpression("tran")
                        ));
                }

                //declare outValues if containOutParam == true
                if (containOutParam)
                {
                    spMethod.Statements.Add(new CodeVariableDeclarationStatement(typeof(Dictionary<string, object>), "outValues"));
                }

                for (int i = 0; i < cmd.Parameters.Count; ++i)
                {
                    //gen add parameter code for parameters
                    switch (cmd.Parameters[i].Direction)
                    {
                        case ParameterDirection.Input:
                            spMethod.Statements.Add(
                                new CodeMethodInvokeExpression(new CodeVariableReferenceExpression("spSection"), "AddInputParameter",
                                    new CodePrimitiveExpression(spMethod.Parameters[i + 1 + (generateTranParam ? 1 : 0)].Name),
                                    new CodeFieldReferenceExpression(new CodeTypeReferenceExpression(typeof(DbType)), cmd.Parameters[i].DbType.ToString()),
                                    new CodeVariableReferenceExpression(spMethod.Parameters[i + 1 + (generateTranParam ? 1 : 0)].Name)
                                ));
                            break;
                        case ParameterDirection.InputOutput:
                            spMethod.Statements.Add(
                                new CodeMethodInvokeExpression(new CodeVariableReferenceExpression("spSection"), "AddInputOutputParameter",
                                    new CodePrimitiveExpression(spMethod.Parameters[i + 1 + (generateTranParam ? 1 : 0)].Name),
                                    new CodeFieldReferenceExpression(new CodeTypeReferenceExpression(typeof(DbType)), cmd.Parameters[i].DbType.ToString()),
                                    new CodePrimitiveExpression(cmd.Parameters[i].Size),
                                    new CodeVariableReferenceExpression(spMethod.Parameters[i + 1 + (generateTranParam ? 1 : 0)].Name)
                                ));
                            break;
                        case ParameterDirection.Output:
                            spMethod.Statements.Add(
                                new CodeMethodInvokeExpression(new CodeVariableReferenceExpression("spSection"), "AddOutputParameter",
                                    new CodePrimitiveExpression(spMethod.Parameters[i + 1 + (generateTranParam ? 1 : 0)].Name),
                                    new CodeFieldReferenceExpression(new CodeTypeReferenceExpression(typeof(DbType)), cmd.Parameters[i].DbType.ToString()),
                                    new CodePrimitiveExpression(cmd.Parameters[i].Size)
                                    ));
                            break;
                        case ParameterDirection.ReturnValue:
                            spMethod.Statements.Add(
                                new CodeMethodInvokeExpression(new CodeVariableReferenceExpression("spSection"), "SetReturnParameter",
                                    new CodePrimitiveExpression(spMethod.Parameters[i + 1 + (generateTranParam ? 1 : 0)].Name),
                                    new CodeFieldReferenceExpression(new CodeTypeReferenceExpression(typeof(DbType)), cmd.Parameters[i].DbType.ToString()),
                                    new CodePrimitiveExpression(cmd.Parameters[i].Size)
                                    ));
                            break;
                    }
                }

                spMethod.Statements.Add(
                    new CodeVariableDeclarationStatement(typeof(DataSet), "ds",
                    containOutParam ? new CodeMethodInvokeExpression(new CodeMethodReferenceExpression(new CodeVariableReferenceExpression("spSection"), "ToDataSet"), new CodeDirectionExpression(FieldDirection.Out, new CodeVariableReferenceExpression("outValues"))) :
                        new CodeMethodInvokeExpression(new CodeVariableReferenceExpression("spSection"), "ToDataSet")
                    ));

                //set output parameter values
                if (containOutParam)
                {
                    for (int i = 0; i < cmd.Parameters.Count; ++i)
                    {
                        Type paramType = GetTypeFromDbType(cmd.Parameters[i].DbType);

                        if (cmd.Parameters[i].Direction != ParameterDirection.Input)
                        {
                            if (paramType.IsValueType)
                            {
                                spMethod.Statements.Add(
                                    new CodeConditionStatement(
                                        new CodeBinaryOperatorExpression(
                                            new CodeIndexerExpression(new CodeVariableReferenceExpression("outValues"), new CodePrimitiveExpression(spMethod.Parameters[i + 1 + (generateTranParam ? 1 : 0)].Name)),
                                            CodeBinaryOperatorType.IdentityEquality,
                                            new CodePrimitiveExpression(null)
                                        ),
                                        new CodeStatement[] { new CodeAssignStatement(
                                            new CodeVariableReferenceExpression(spMethod.Parameters[i + 1 + (generateTranParam ? 1 : 0)].Name),
                                            new CodeDefaultValueExpression(new CodeTypeReference(paramType))
                                            )},
                                        new CodeStatement[] { new CodeAssignStatement(
                                            new CodeVariableReferenceExpression(spMethod.Parameters[i + 1 + (generateTranParam ? 1 : 0)].Name),
                                            new CodeCastExpression(paramType, new CodeIndexerExpression(new CodeVariableReferenceExpression("outValues"), new CodePrimitiveExpression(spMethod.Parameters[i + 1 + (generateTranParam ? 1 : 0)].Name)))
                                            )}
                                    )
                                );
                            }
                            else
                            {
                                spMethod.Statements.Add(new CodeAssignStatement(
                                    new CodeVariableReferenceExpression(spMethod.Parameters[i + 1 + (generateTranParam ? 1 : 0)].Name),
                                    new CodeCastExpression(paramType, new CodeIndexerExpression(new CodeVariableReferenceExpression("outValues"), new CodePrimitiveExpression(spMethod.Parameters[i + 1 + (generateTranParam ? 1 : 0)].Name)))
                                    ));
                            }
                        }
                    }
                }

                //return
                spMethod.Statements.Add(new CodeMethodReturnStatement(new CodeVariableReferenceExpression("ds")));
            }
        }

        private Type GetTypeFromDbType(DbType dbType)
        {
            switch (dbType)
            {
                case DbType.AnsiString:
                case DbType.AnsiStringFixedLength:
                case DbType.String:
                case DbType.StringFixedLength:
                case DbType.Xml:
                    return typeof(string);
                case DbType.Binary:
                    return typeof(byte[]);
                case DbType.Boolean:
                    return typeof(bool);
                case DbType.Byte:
                    return typeof(byte);
                case DbType.Currency:
                case DbType.Decimal:
                    return typeof(decimal);
                case DbType.Date:
                case DbType.DateTime:
                case DbType.Time:
                    return typeof(DateTime);
                case DbType.Double:
                case DbType.VarNumeric:
                    return typeof(double);
                case DbType.Single:
                    return typeof(float);
                case DbType.Guid:
                    return typeof(Guid);
                case DbType.Int16:
                    return typeof(short);
                case DbType.Int32:
                    return typeof(int);
                case DbType.Int64:
                    return typeof(long);
                case DbType.SByte:
                    return typeof(sbyte);
                case DbType.UInt16:
                    return typeof(ushort);
                case DbType.UInt32:
                    return typeof(uint);
                case DbType.UInt64:
                    return typeof(ulong);
            }

            return typeof(string);
        }

        private void copyAllToClipboardToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Clipboard.SetText(output.Text);
        }

        private void txtConnStr_TextChanged(object sender, EventArgs e)
        {
            if (txtConnStr.Text.ToLower().Contains("microsoft.jet.oledb"))
            {
                radioAccess.Checked = true;
                checkSql2005.Enabled = false;
            }
            else if (txtConnStr.Text.ToLower().Contains("data source") && txtConnStr.Text.ToLower().Contains("user id") && txtConnStr.Text.ToLower().Contains("password"))
            {
                radioOracle.Checked = true;
                checkSql2005.Enabled = false;
            }
            else if (txtConnStr.Text.ToLower().Contains("dsn="))
            {
                radioMySql.Checked = true;
                checkSql2005.Enabled = false;
            }
            else if (txtConnStr.Text.ToLower().Contains("5432"))
            {
                radioPostgreSql.Checked = true;
                checkSql2005.Enabled = false;
            }
            else if (txtConnStr.Text.ToLower().Contains(".db3"))
            {
                radioSqlite.Checked = true;
                checkSql2005.Enabled = false;
            }
            else
            {
                radioSql.Checked = true;
                checkSql2005.Enabled = true;
            }
        }

        private void radioSql_CheckedChanged(object sender, EventArgs e)
        {
            checkSql2005.Enabled = radioSql.Checked;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            outputLanguage.SelectedIndex = 0;

            LoadConnectionStringAutoComplete();
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            SaveConnectionStringAutoComplete();
        }

        private void txtSaveAs_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                System.IO.File.WriteAllText(saveFileDialog1.FileName, output.Text);
                MessageBox.Show("Saved!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information, MessageBoxDefaultButton.Button1);
                saveFileDialog1.FileName = string.Empty;
            }
        }
    }
}